<template>
    <div>
        <#if ctrl.getQuickSearchMode() gt 0>
        <i-input v-model="query" @on-change="onQueryChange" placeholder="<#if ctrl.getPSSearchBarQuickSearchs()??><#list ctrl.getPSSearchBarQuickSearchs() as search><#if search_index gt 0>,</#if><#if search.getPSDEField()??>${search.getPSDEField().getLogicName()}</#if></#list></#if>" style="<#if ctrl.getQuickSearchWidth() gt 0>width: ${ctrl.getQuickSearchWidth()?c}px;</#if>"></i-input>
        </#if>
        <div v-if="filterFields.length > 0" class="filter-group">
            <template v-for="(item, index) of filterItems">
                <filter-item :key="index" :data="item" :filterFields="filterFields">
                    <template slot-scope="{data}">
                        <#if ctrl.getPSSearchBarFilters()??>
                        <#list ctrl.getPSSearchBarFilters() as filter>
                        <template v-if="Object.is(data.field, '<#if filter.getPSDEField()??>${filter.getPSDEField().getCodeName()?lower_case}<#else>${filter.getName()}</#if>')">
                            ${P.getEditorCode(filter, "EDITOR.vue").code}
                        </template>
                        </#list>
                        </#if>
                    </template>
                </filter-item>
            </template>
        </div>
    </div>
</template>
<#ibizinclude>
../@MACRO/CONTROL/CONTROL_HEADER-BASE.vue.ftl
</#ibizinclude>

    /**
     * 快速搜索值
     *
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public query: string = '';

    /**
     * 过滤属性集合
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    get filterFields() {
        return Object.vals(this.detailsModel);
    }

    /**
     * 过滤属性模型集合
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public detailsModel: any = {
        <#if ctrl.getPSSearchBarFilters()??>
        <#list ctrl.getPSSearchBarFilters() as filter>
        '${filter.getName()}': {
            label: '${filter.getCaption()}',
            prop: '<#if filter.getPSDEField()??>${filter.getPSDEField().getCodeName()?lower_case}<#else>${filter.getName()}</#if>',
            disabled: false
        },
        </#list>
        </#if>
    };

    /**
     * 过滤项集合
     *
     * @type {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public filterItems: any[] = [];

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getData(): any {
        return null;
    }

    /**
     * 快速搜索框值变化
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onQueryChange($event: any) {
        this.$emit('on-change', { query: this.query });
    }

    /**
     * 过滤项值变化
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public onFilterChange($event: any) {
        this.$emit('on-change', { filter: '' });
    }


<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL-BASE.style.ftl
</#ibizinclude>